{
  knihovny hleda k pocitaci pripojenou GPS nebo telefons aplikaci pro geocaching

  - vraci string s nalezenym diskem nebo MTP zarizenim
    za jmenem zarizeni je ' - Garmin GPS' nebo ' - MTP' jako priznak
    typu zarizeni

  1.0 31.08.2016 Gord
}

{$include MtpToolLib.dll.pas}

const //pro hledani souboru
      GARMIN='\Garmin\GarminDevice.xml';
      ADRAKE_MTP_DIR='/Android/data/cz.adrake/files'; //adresar pro MTP
      ADRAKE_MSS_DIR='\adrake|\Android\data\cz.adrake\files'; //adresar(e) pro Mass Storage
      //data mohou byt na karte i v pripade, ze je nainstalovany v telefonu
      ADRAKE_INI='aDrake.ini'; //tento soubor hledame, podle nej pozname instalaci
                               //v ini je cesta k databazi, ale tam je zapsana
                               //v internim tvaru, kry karta je "/storage/<kod>"
                               //zatimco v MTP je videitelna jako "Karta SD"
      //LOCUS_DIR='';
      //LOCUS_INSTALL='';
      //LOCUS_DB='';
      TMPFILE='MtpToolLib.tmp';          //jmeno pracovniho souboru
      TMPINI='MtpToolLib.ini.tmp';       //jmeno pracovniho ini souboru

var dList:TListBox; //seznam ve formulari pro vyber zarizeni

procedure FindGpsGarmin(bType:boolean);
var sDisk:string;
    i:integer;
begin
  //napred to jednodussi - prohledame vsechny pripojene disky
  for i:=0 to 25 do begin
    sDisk:=Chr(65+i)+':';
    if(not DiskInDrive(sDisk)) then continue;
    if(FileExists(sDisk+GARMIN)) then begin
      if(bType) then dList.Items.Add(sDisk+' [GARMIN]')
      else dList.Items.Add(sDisk);
    end;
  end;
end;

procedure FindAdrakeMss(sType:string);
var i,iDir,j,jDir:integer;
    s,s1,sDisk,sFile:string;
    aDirs:TStringList;
    ini:TMemIniFile;
begin
  aDirs:=TStringList.Create();
  try
    aDirs.Text:=ReplaceString(ADRAKE_MSS_DIR,'|',CRLF);
    //hledame instalacni adresar (obsahuje aDrake.ini) na discich
    for i:=0 to 25 do begin
      sDisk:=Chr(65+i)+':';
      if(not DiskInDrive(sDisk)) then continue;
      for iDir:=0 to aDirs.Count-1 do begin
        sFile:=sDisk+aDirs[iDir]+'\'+ADRAKE_INI;
//{$ifdef DEBUG_HELPER} LDH('Test disku '+sFile);{$endif}
        if(FileExists(sFile)) then begin
{$ifdef DEBUG_HELPER} LDH('Nalezeno: '+sFile);{$endif}
          if(sType='ADRAKE_INST') or (sType='*') then dList.Items.Add(sDisk+aDirs[iDir]+' [ADRAKE_INST]');
          if(sType='ADRAKE_DB') or (sType='*') then begin
            //nacteme soubor a z nej databazi
            ini:=TMemIniFile.Create(sFile);
            try
              s:=ini.ReadString('Options','DbFile',''); // =/storage/9016-4EF8/Android/data/cz.adrake/files/geoget.db3
            finally
              ini.Free();
            end;
            //pro pripad, ze je DB nekde jinde na karte, z cesty odstranime
            //prvni dve polozky (/mnt/sdcard nebo neco podobneho, co ukazuje na
            //namonovanou SD kartu, databazi jinde v telefonu uz neuvazuji)
            //a docasne ho pridame k adresarum
{$ifdef DEBUG_HELPER} LDH('pouzivana databaze: '+s);{$endif}
            s1:=ReplaceString(RegexSubstitute('/.*?/.*?(/.*)/.*',s,'$1'),'/','\');
{$ifdef DEBUG_HELPER} LDH('montovany adresar pro SD kartu: '+s1);{$endif}
            if(s1<>'') then aDirs.Add(s1);
            for j:=0 to aDirs.Count-1 do begin //adresar pridame jen pokud jeste neni
              if(aDirs[j]=s1) then begin
                s1:='';
                break;
              end;
            end;
            s:=RegexReplace('.*/',s,'',false); //nechame jen jmeno databazoveho souboru
{$ifdef DEBUG_HELPER} LDH('aDrake (Mass Storage) pouziva databazi: '+s);{$endif}
            if(s='') then continue;
            //zkusime najit databazi na vsech discich v moznych adresarich
            for j:=0 to 25 do begin
              sDisk:=Chr(65+j)+':';
              if(not DiskInDrive(sDisk)) then continue;
              for jDir:=0 to aDirs.Count-1 do begin
                sFile:=sDisk+aDirs[jDir]+'\'+s;
                if(FileExists(sFile)) then
                  dList.Items.Add(sFile+' [ADRAKE_DB]');
              end;
            end;
            if(s1<>'') then aDirs.Delete(aDirs.Count-1); //vymazeme docasne pridany adresar
          end;
        end;
      end;
    end;
  finally
    aDirs.Free();
  end;
end;

procedure FindAdrake(sType:string);
var s,sFileIni,sFileDb,sFile,sDev:ansistring;
    ini:TMemIniFile;
    s1:string;
    j,iDev,iObj:integer;
    aDevices,aFObjs,aCategory:TStringList;
begin
{$ifdef DEBUG_HELPER} LDH('FindAdrake('+sType+')');{$endif}
  FindAdrakeMss(sType);//napred prohledame vsechny disky (android pripojen jako MassStorage)
  aDevices:=TStringList.Create();
  try
    aDevices.Text:=ML_Devices();
{$ifdef DEBUG_HELPER} LDH('Seznam pripojenych zarizeni:'+ReplaceString(Trim(aDevices.Text),CRLF,', '));{$endif}

    for iDev:=0 to aDevices.Count-1 do begin
      sDev:=ReplaceString(Trim(aDevices[iDev]),'\',''); //sachty na ctece maji na konci '\', ostranime jej
      if(sDev[2]=':') then begin //ignorujeme neexistujici zarizeni
        //nebo ignorovat bez ohledu na DiskInDrive, protoze to znamena pripojeni jako Mass Storage?
        {if(not DiskInDrive(sDev)) then} continue;
      end;
{$ifdef DEBUG_HELPER} LDH('Test zarizeni: '+sDev);{$endif}
      ML_SetDeviceName(sDev);               //nastavit pouzivane zarizeni
      aFObjs:=TStringList.Create();
      try
        aCategory:=TStringList.Create();
        try
          aCategory.Text:=Trim(ML_FunctionalObjects());
          for iObj:=0 to aCategory.Count-1 do begin
            s1:=aCategory[iObj];
            Fetch(s1,':'); //zahodime ID kategorie (mozna by bylo dobre brat jen WPD_FUNCTIONAL_CATEGORY_STORAGE)
            while(s1<>'') do begin
              aFObjs.Add(Fetch(s1,',')); //pridame funkcni objekt
            end;
          end;
        finally
          aCategory.Free();
        end;
{$ifdef DEBUG_HELPER} LDH('    Seznam funkcnich objektu (vsech kategorii): '+ReplaceString(Trim(aFObjs.Text),CRLF,', '));{$endif}
        for iObj:=0 to aFObjs.Count-1 do begin
          //priznak, zda existuje soubor
          sFileIni:=aFObjs[iObj]+ADRAKE_MTP_DIR+'/'+ADRAKE_INI;
          if(ML_Exists(sFileIni)=1) then begin  //hodnota <>1 znamena nenalezeno nebo chyba
{$ifdef DEBUG_HELPER} LDH('    aDrake.ini: nalezen v objektu: '+aFObjs[iObj]);{$endif}
//{$ifdef DEBUG_HELPER} LDH('i='+IntToStr(i));{$endif}
            if(sType='ADRAKE_INST') or (sType='ALL_APPS') then dList.Items.Add(sDev+':'+aFObjs[iObj]+ADRAKE_MTP_DIR+' [ADRAKE_INST]');
            if(sType='ADRAKE_DB') or (sType='ALL_APPS') then begin
              sFile:=GEOGET_DATADIR+'\'+TMPINI;
{$ifdef DEBUG_HELPER} LDH('    Zkopirovani INI souboru do '+sFile);{$endif}
//              continue; // *****************************************************
              j:=ML_GetFile(sFileIni,sFile,true);
{$ifdef DEBUG_HELPER} LDH('    Po zkopirovani INI souboru do '+sFile);{$endif}
              if(j=0) then begin  //uspesne zkopirovano
                if(not FileExists(sFile)) then begin
                  ShowMessage('Nepodarilo se zkopirovat '+sFile+CRLF+CRLF+ML_GetErrorMessage());
                end
                else begin
                  ini:=TMemIniFile.Create(sFile);
                  try
                    s:=ini.ReadString('Options','DbFile',''); // =/storage/9016-4EF8/Android/data/cz.adrake/files/geoget.db3
                  finally
                    ini.Free();
                  end;
                  /////////////DeleteFile(sFile);
                  s:=RegexReplace('.*/',s,'',false); //nechame jen jmeno databazoveho souboru
{$ifdef DEBUG_HELPER} LDH('    aDrake pouziva databazi: '+s);{$endif}
                  //zkusime najit databazi na vsech funkcnich zarizenich
                  for j:=0 to aFObjs.Count-1 do begin
                    sFileDb:=aFObjs[j]+ADRAKE_MTP_DIR+'/'+s;
                    if(ML_Exists(sFileDb)=1) then
                      dList.Items.Add(sDev+':'+sFileDb+' [ADRAKE_DB]');
                    //ShowMessage(aPom.Text);
                    //aPom.Free();
                  end;
                end;
              end;
            end;
          end;
          //
          //sCmd:='get %dev% %fobj%%ADRAKE_MTP_DIR%/%ADRAKE_INI%'; //ziskam obsah souboru a prectu z nej jmeno souboru s databazi
          //sCmd:='exists %dev% %fobj%%ADRAKE_MTP_DIR%/%ADRAKE_DBFILE%'; //zjistim, zda existuje databaze, musim testovat vsechny funkcni objekty (interni uloziste i karty)
        end;
      finally
        aFObjs.Free();
      end;
    end;
  finally
    aDevices.Free();
  end;
  //ted MTP:
  //ziskame seznam moznych zarizeni
  //pro kazde zarizeni hledame na karte i v internim ulozisti
end;

procedure butRefreshOnClick(sender:TObject);//zadani souradnic
var dForm:TForm;
    but:TButton;
    i:integer;
    lType:TLabel;
    //c:TComponent;
begin
  but:=(sender as TButton);
  dForm:=(but.Parent as TForm);
  ML_SetProgressBarInt(0);                //zakazeme zobrazeni progressbaru pri kopirovani pracovnich souboru
  for i:=0 to dForm.ComponentCount-1 do begin
    if(dForm.Components[i].Name='lType') then begin
      lType:=(dForm.Components[i] as TLabel);
      case lType.Caption of
      'GARMIN':         FindGpsGarmin(true);
      'ADRAKE_INST':    FindAdrake('ADRAKE_INST');
      'ADRAKE_DB':      FindAdrake('ADRAKE_DB');
      'ALL_APPS': begin FindGpsGarmin(true); FindAdrake('ALL_APPS'); end;
      'ALL_DEVS':       dList.Items.Text:=Trim(ML_Devices());
      else ShowMessage('ML_FindGpsMobileDevice(): Unknown type of device: "'+lType.Caption+'"');
      end;
      break;
    end;
  end;
  ML_SetProgressBarInt(ML_iShowProgress-ML_INIT_SHOWPROGRES_VALUE); //vratime zpet zobrazovani progressbaru
end;

function ML_FindGpsMobileDevice(sType:string; bAlwaysShowSelection:boolean):string;
var dForm:TForm;
    butOk,butRefresh:TButton;
    lType:TLabel;
    iOldShowProgress:integer;
    //s:ansistring;
    //sRes:ansistring;
    //iLen:integer;
begin
  Result:='';
  iOldShowProgress:=ML_iShowProgress-ML_INIT_SHOWPROGRES_VALUE;
  //pokud nebyla hodnota inicializovana, inicializujeme ji s povolenym zobrazenim
  if(iOldShowProgress<0) or (iOldShowProgress>1) then iOldShowProgress:=1;
  ML_iShowProgress:=iOldShowProgress+ML_INIT_SHOWPROGRES_VALUE; //vratime puvodni hodnotu

  {$ifdef DEBUG_HELPER} LDHInit(true); {$endif}
  //sType je typ, ktery se ma zjistovat
  //   GARMIN
  //   ADRAKE_INST - instalace aDrake
  //   ADRAKE_DB   - databaze aDrake (jeji jmeno je v aDrake.ini souboru)
  ////////LOCUS takto obsluhovat nejde, protoze konfigurace je ulozena v XML
  ////////      citelnem jen jako root. Addon muze mit databazi uplne kdekoli
  ////////      bez ohledu na moznost zapisu, protoze addon je kompilovany pro
  ////////      starsi androidy.
  ////////      LOCUS_INST  - instalace Locusu
  ////////      LOCUS_DB    - databaze Locusu
  //   ALL_APPS    - hleda vsechny aplikace (viz predchozi radky), vraci string
  //                 se seznamem kazdy radek v nem pak obsahuje i typ zarizeni
  //   ALL_DEVS    - vsechna pripojena zarizeni bez ohledu na aplikace
  //pokud najde vice pozadovanych zarizeni, necha uzivatele vybrat a vraci
  //nalezene (pokud je nalezeno jedine) nebo vybrane zarizeni

  //vytvorime formular pro vyber zarizeni
  dForm:=TForm.Create(nil);
  dForm.BorderStyle:=bsDialog;
  dForm.Caption:=_('Select the device'); //##_EN_##
  dForm.Position:=poDesigned;
  dForm.Height:=190;
  dForm.Width:=505;
  //polohu okna vystredime na obrazovce
  dForm.Left:=(Screen.Width-dForm.Width)/2;
  dForm.Top:=(Screen.Height-dForm.Height)/2;
  butOk:=TButton.Create(dForm);
    with butOk do begin
    Parent:=dForm; Caption:=_('Use'); Hint:=''; //##_EN_##
    Top:=132; Left:=422; Width:=75; Height:=25;
    Font.Height:=-13; Font.Name:='Tahoma';
    Name:='butOk';
    ModalResult:=1;
    end;
  butRefresh:=TButton.Create(dForm);
    with butRefresh do begin
    Parent:=dForm; Caption:=_('List Refresh'); Hint:=''; //##_EN_##
    Top:=132; Left:=3; Width:=75; Height:=25;
    Font.Height:=-13; Font.Name:='Tahoma';
    Name:='butRefresh';
    end;
  dList:=TListBox.Create(dForm);
    with dList do begin
    Parent:=dForm;
    Top:=7; Left:=3; Width:=493; Height:=121;
    Font.Height:=-13; Font.Name:='Tahoma';
    Style:=lbStandard;
    Name:='dList';
    end;
  lType:=TLabel.Create(dForm);
    with lType do begin
    Parent:=dForm;
    Visible:=false;
    Caption:=sType;
    Name:='lType';
    //Top:=7; Left:=3; Width:=493; Height:=121;
    //Font.Height:=-13; Font.Name:='Tahoma';
    //Style:=lbStandard;
    end;
  butRefresh.OnClick:=@butRefreshOnClick;  //obsluha tlacitka
  dList.Items.Text:=''; //vynulovat seznam

  butRefreshOnClick(butRefresh as TObject);
  {
  case sType of
  'GARMIN':         FindGpsGarmin(true);
  'ADRAKE_INST':    FindAdrake('ADRAKE_INST');
  'ADRAKE_DB':      FindAdrake('ADRAKE_DB');
  'ALL_APPS': begin FindGpsGarmin(true); FindAdrake('ALL_APPS'); end;
  'ALL_DEVS':       dList.Items.Text:=Trim(ML_Devices());
  else ShowMessage('ML_FindGpsMobileDevice(): Unknown type of device: "'+sType+'"');
  end;
  }
  dList.ItemIndex:=0;   //vybereme prvni zarizeni v seznamu
                                        //pokud zadne neni, hodnota zustane -1
  if(dList.Items.Count>1) or (bAlwaysShowSelection) then begin
    if(dForm.ShowModal()<>1) then dList.ItemIndex:=-1;
  end;
//{$ifdef DEBUG_HELPER} LDH('Vybrana polozka seznamu: '+IntToStr(dList.ItemIndex)); {$endif}
  if(dList.ItemIndex>=0) then begin
    Result:=dList.Items[dList.ItemIndex];
  end;
  dList.Free();
  butOk.Free();
  butRefresh.Free();
  dForm.Free();
end;